=== debian/changelog ===
obs-studio (23.2.1-0obsproject1~bionic+pearl10) buster; urgency=medium

  * Pearl build for 10

 -- Scott Vandergrift <scottvandergrift@gmail.com>  Fri, 19 Mar 2021 19:43:56 -0500

obs-studio (23.2.1-0obsproject1~0.1pearl10) buster; urgency=medium

  * Pearl build for 10

 -- Scott Vandergrift <scottvandergrift@gmail.com>  Fri, 19 Mar 2021 19:39:56 -0500

obs-studio (23.2.1-0obsproject1~bionic) bionic; urgency=low

  OBS Studio 23.2.1

  23.2.1 Hotfix Changes

  * Fixed a crash that could happen with the popular third-party obs-ndi plugin
  * Fixed the tray icon being shown even when the tray icon was disabled in settings
  * Fixed a display bug with sources when a custom color was applied to the list item in the sources list box
  * Fixed a bug where background-removing cameras would have a hall of mirrors effect

  23.2 New Features/Improvements

  * Made a number of major internal improvements to the macOS browser source, eliminating many mac-related crashes that it would cause when browser sources were in use on macOS.  This also fixes the issue of the program having an initial startup delay where the everything appeared blank.  (Author note: I managed to get browser panels functioning, but they still have some issues, so service integration is still not yet available on macOS)
  * Added the ability to preview transitions in the properties of a transition via a new Preview button
  * Added an estimate to remaining available recording time according to available disk space
  * Added luma key video effect filter
  * Added the ability to set the exact desired dB volume value of sources in the advanced audio properties, replacing the percentage value
  * Added the ability to center items vertically/horizontally in the transform menus
  * Added a hotkey to toggle the preview
  * Added the ability to output the preview rather than program to a decklink device when in studio mode
  * Added the ability to copy and paste filters to/from scenes in addition to sources
  * Added the ability to manually set the network buffer size to the Media source when used in URL mode
  * Added the top patrons list to the about dialog in the help menu
  * The sources list box in the bottom-center of the main window now displays a message when there are no sources in the current scene, making it easier for first-time users to understand that they need to add sources

  23.2 Bug Fixes/Tweaks

  * Fixed an issue on Linux where the program would not be able to capture some monitors
  * Fixed a bug where the "test bandwidth" option wouldn't reset properly until the program was restarted
  * Fixed a bug where the program would freeze up when an encoder error occurs in the middle of a recording or stream (it now shows an error and should now safely recover)
  * Fixed a bug where the selection lines of rotated items would incorrectly scale
  * Fixed a bug where audio would no longer work when certain types of audio devices are unplugged and plugged back in again
  * Fixed a bug where you could not press escape to cancel when renaming a scene
  * Fixed a bug where opacity on the mask/blend filter would not work under certain circumstances
  * Fixed a bug where fractional framerate recordings (59.94, 29.97) recorded with the new version of NVENC would have incorrect DTS timestamps in the recording file
  * Fixed an issue with VAAPI encoder on Linux where CBR would not always output at a constant bitrate
  * Fixed an issue where cookies would not properly be saved for browser panels (Twitch Chat/etc) when shutting down the program
  * Fixed some crashes that could happen when using QSV
  * Fixed a few rare crashes
  * Fixed a few rare/minor memory leaks
  * Recording errors should now gives more detailed errors when they occur
  * Replaced most icons with SVG icons, making icons look better and more consistent across different DPI scalings
  * Made the mouse wheel scroll the list of properties instead of scrolling individual property values in properties windows
  * Made the mouse wheel scroll the list of mixer items instead of scrolling individual mixer values
  * Moved audio monitoring device from advanced settings to audio settings
  * Improved logging when recording errors occur
  * Added a warning popup message box to Twitch authentication if the account is not set up for two-factor authentication (which is now required to stream on Twitch)
  * Removed the 5 item limit when dragging and dropping files in to OBS
  * Buttons in the Hotkeys list are now icons rather than text
  * Changed all opacity spin boxes in filters to sliders
  * Changed the default size of the color source to the same size as the canvas
  * Made the Dark theme a bit more consistent across operating systems
  * Scene item group details are now included in the log file
  * The stats dock no longer updates when it's not visible
  * When first renaming a source or scene, the existing text is now automatically selected
  * The Dark theme has now been renamed to "Dark (Default)", and the "Default" theme has now been renamed to the "System" theme
  * The cursor is no longer hidden in multiview projectors

 -- Kevin Henkel <obs.goldace@gmail.com>  Sat, 15 Jun 2019 22:42:54 +0200
